var Api = require('../../utils/api.js');
var Util= require('../../utils/util.js');
var app = getApp();

// pages/QRcode/QRcode.js
Page({
  /**
   * 页面的初始数据
   */
  data: {
    src: '',
    ops: [[350, 375, 395], [280, 305, 325]],
    act: 1,
    title: "",
    result: 3,
    flag: true,
    src_1: '',
    item: { unitid: true },
    btn_2: 0,
    dataimg: [],
    ret: 0,
    lbpd: 0,
    shouquan: 0,
    canvasshow: false,
    modal: true,
    txt:"",
    min: 0,
    g_id:'',
    type:'',
    is_yzm:''
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    var that = this;
    wx.setNavigationBarTitle({
      title: "量表二维码"
    })
    if(options.type !=1){
      this.setData({
        g_id:options.id,
      })
    }
    var user = wx.getStorageSync('user');
    var xiaoshou = options.xiaoshou ? options.xiaoshou : 0;
    if (xiaoshou == '1') {
      if (this.data.iPhoneX) {
        var item = { index: -1, unitid: false, iphonex: true };
      } else {
        var item = { index: -1, unitid: false, iphonex: false };
      }
    } else {
      if (this.data.iPhoneX) {
        var item = { index: -1, unitid: true, iphonex: true };
      } else {
        var item = { index: -1, unitid: true, iphonex: false };
      }
    }
    this.setData({
      item: item,
      txt:options.g_name
    })
    // 加载数据
    var lbtype = options.type ? options.type : 0;
    this.setData({ lbtype: lbtype})
    if (lbtype == 1) {   //  选择量表
      this.setData({
        lbpd: 1,
        shouquan: 0
      })
      this.User1();
    } else if (lbtype == 2) {   //  授权记录
      this.setData({
        result: 1,
        shouquan: 1
      })
      var str = Api.HOST + "Public/yanzheng/er.png";
      var src = wx.getStorageSync('qrSrc');

      this.main(src, str);
    } else {
      this.User();
    }
  },
  /**
   * 自定义功能函数---跳转协议页面
   *   
   * **/
  Argeement() {
    wx.navigateTo({
      url: '/pages/agreement/agreement',
    })
  },
  switchCode(e){
    console.log("switchCode",this.data.is_yzm)
    var data = {};
    if (Number(this.data.is_yzm) == 1) {
      this.setData({
        is_yzm: 2
      })
      data.is_yzm = 2;
    } else {
      this.setData({
        is_yzm: 1
      })
      data.is_yzm = 1;
    }

    let that = this;
    var url = Api.HOST + 'wechat.php?s=Measure/gauge_up';
    var user = wx.getStorageSync('user');
    // data.openid = user.openid;
    data.id = this.data.g_id;
    // return;
    console.log("switchCode",data)
    Api.fetchPost(url, data, (err, res) => {
      console.log('gauge_up',res)
      if (res == 1) {
        console.log('ok')
        that.setData({ queding: true })
      }
    })
  },
  /**
   * 自定义函数 --更换头像
   * 
   * **/
  changePortrait() {
    let that = this;
    var data = {};
    var url = Api.HOST + 'wechat.php?s=/Vip/isStatus';
    var user = wx.getStorageSync('user');
    var userData = wx.getStorageSync('data');
    data.openid = user.openid;
    data.qrcodejudge = userData.qrcodejudge;
    // data.qrcodejudge = 
    Api.fetchPost(url, data, (err, res) => {
      if (that.data.ret == 1) {
        that.setData({
          ret: 0
        })
      } else {
        that.setData({
          ret: 1
        })
      }
      // 销售和咨询师更换二维码样式
      if (that.lbpd == 1) {
        // that.User1();
      } else {
        that.User();
      }
    });
  },
  /**
   * 自定义函数--更多样式
   * 
   * */
  moreStyle() {
    wx.navigateTo({
      url: '/pages/qrlist/qrlist',
    })
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    let that = this;
    wx.getSystemInfo({
      success: (res) => {
        console.log(res.model,'555')
        if (res.model.indexOf("iPhone 5") > -1) {
          that.setData({
            min: 1
          })
        }else{
          that.setData({
            min: 0
          })
        }
        if (/^iPhone X.*/i.test(res.model)) {
          that.setData({
            iPhoneX: true,
            winH: res.windowHeight - 75
          })
        } else {
          that.setData({
            iPhoneX: false,
            winH: res.windowHeight - 50
          })
        }
      }

    });
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    let that = this;
  },
  // 合并图片
  main(src, str, t) {
    console.log("src",src)
    let that = this;
    var ctx = wx.createCanvasContext('can')
    var qrTime = wx.getStorageSync('qrTime') || -1;
    if (this.data.shouquan == 1) {
      var ti = Api.timestampToTime(qrTime)
    } else {
      var ti = Api.timestampToTime(t)
    }
    var txt = this.data.txt ? this.data.txt:'';
    Util.base64src(src).then(srcUrl=>{
      console.log('srcUrl',srcUrl)
        wx.hideLoading()
        wx.getSystemInfo({
          success: (res) => {
            var winW = res.windowWidth;
            // ctx.drawImage(imgSrc, 0, 0, winW, winW * 1.12)
            ctx.setFillStyle('rgb(255,255, 255)')
            ctx.fillRect(0, 0, winW, that.data.winH*0.74)
            ctx.draw(true)
            ctx.setFontSize(14);
            ctx.setC;
            ctx.setTextAlign('center')
            ctx.setFillStyle('rgb(102, 102, 102)');
            ctx.fillText('微信扫一扫，使用小程序', (winW / 2), that.data.ops[that.data.min][0]);
            ctx.draw(true);
            ctx.setFontSize(11);
            ctx.setC;
            ctx.setTextAlign('center')
            ctx.setFillStyle('rgb(102, 102, 102)');
            ctx.fillText(ti, (winW / 2), that.data.ops[that.data.min][1]);
            ctx.draw(true);
            ctx.setFontSize(11);
            ctx.setC;
            ctx.setTextAlign('center')
            ctx.setFillStyle('rgb(102, 102, 102)');
            ctx.fillText(txt, winW / 2, that.data.ops[that.data.min][2]);
            // ctx.textAlign = align;
            ctx.draw(true);
            // ctx.drawImage(src, (winW / 2 - winW * 0.37 / 2), (winW * 1.12 / 2 - winW * 0.37 / 2 - 10), winW * 0.37, winW * 0.37)
            ctx.drawImage(srcUrl, (winW / 2 - winW * 0.6 / 2), (winW * 1.12 / 2 - winW * 0.6 / 2 - 32), winW * 0.6, winW * 0.6);
            ctx.draw(true);
          }
        })
      })
  },
  User() {
    let that = this;
    var url = Api.HOST + 'wechat.php?s=Vip/isGetEr';
    var data = {};
    var user = wx.getStorageSync('user');
    var userData = wx.getStorageSync('data');
    data.openid = user.openid;
    Api.fetchPost(url, data, (err, res) => {
      wx.showLoading({
        title: '正在生成中',
        icon: 'loading',
      })
      var str = Api.HOST + "Public/yanzheng/er.png";
      if (that.data.ret == "1") {
        that.main(res.qrimg, str);
        wx.setStorageSync('erweima', res.qrimg);
      } else {
        that.main(res.qrcode, str);
        wx.setStorageSync('erweima', res.qrcode);
      }
      that.setData({
        result: res.ret,
      })
    });
  },
  // 对数据库进行增加
  User1() {
    let that = this;
    // var qrTime = wx.getStorageSync('qrTime') || -1;
    // if (qrTime ==-1) wx.removeStorageSync('qrTime')
    var url = Api.HOST + 'wechat.php?s=Measure/gauge';
    var data = {};
    var unitid = wx.getStorageSync('unitid');
    var lbtijiao = wx.getStorageSync('lbtijiao');
    var user = wx.getStorageSync('user');
    data.openid = user.openid;
    data.measure_id_z = lbtijiao.measure_id_z;
    data.measure_id_t = lbtijiao.measure_id_t;
    data.measure_id = lbtijiao.measure_id;
    data.price = lbtijiao.price;
    data.money = lbtijiao.money;
    data.status = lbtijiao.status;
    data.is_type = lbtijiao.is_type;
    data.unitid = unitid;
    data.measure_name = lbtijiao.measure_name;
    data.repeat_code = lbtijiao.repeatCod;
    Api.fetchPost(url, data, (err, res) => {
      console.log(res, 'reee')
      // 清楚量表相关的缓存数据
      wx.removeStorageSync('liangbiao');
      // wx.removeStorageSync('lbtijiao');
      wx.removeStorageSync('lbprice');
      wx.removeStorageSync('matchdata');
      wx.removeStorageSync('lbprice_1');
      wx.removeStorageSync('lbname_1');
      wx.removeStorageSync('lbid_1');
      wx.removeStorageSync('lbtype');
      wx.showLoading({
        title: '正在生成中',
        icon: 'loading',
      })
      wx.setStorageSync("worklb", res)
      var str = Api.HOST + "Public/yanzheng/er.png";
      that.setData({
        result: 1,
        g_id:res.data.g_id
      })
      wx.setStorageSync('img_base64', res.data.img_base64)
      console.log(wx.getStorageSync('img_base64'))
      that.main(res.data.img_base64, str, res.data.g_time);

    });
  },
  // 计算宽度
  wid() {
    var a = wx.getSystemInfo({
      success: (res) => {
        var winW = res.windowWidth;
        return (winW);
      }
    })
  },
  // 保存图片到本地
  savePho: function () {
    wx.showLoading({
      title: '正在保存',
      icon: 'loading',
    })
    var that = this;
    if (that.data.flag) {
      that.setData({ act: 0, flag: false });
      wx.getSystemInfo({
        success: (res) => {
          // console.log('getSystemInfo')
          var winW = res.windowWidth;
          winW = winW;
          setTimeout(() => {
            wx.canvasToTempFilePath({
              x: 0,
              y: 0,
              width: winW,
              height: that.data.winH*0.74,
              canvasId: 'can',
              fileType: 'jpg',
              success: function (res) {
                var imgSrc = res.tempFilePath;
                console.log(res, 'res')
                wx.saveImageToPhotosAlbum({
                  filePath: imgSrc,
                  success: function (res) {
                    wx.hideLoading()
                  },
                  fail: function () {
                    wx.showToast({
                      title: '保存失败',
                      icon: 'success',
                      duration: 300
                    })
                  },
                  complete: function () {
                    that.setData({ act: 1, flag: true });
                  }
                })
              },
              fail: function () {
                console.log('can0')
              },
              complete: function () {
                console.log('can1')
              }
            }, 300)
          })
        }
      })
    }
  },
  dealPho(str, host) {
    return str.replace(".", host);
  },
  note: function(){
    this.setData({
      canvasshow:true,
      modal:false
    })
  },
  modalc: function(){
    this.setData({
      canvasshow: false,
      modal: true
    })
  },
  modalg: function(e){
    let that = this;
    var txt = that.data.txt
    var url =  Api.HOST + "wechat.php?s=Measure/gauge_up"
    var data = {};
    data.g_name = txt;
    data.id = that.data.g_id
    Api.fetchPost(url, data, (err, res) => {
    }) 
    that.setData({
      canvasshow: false,
      modal: true
    })
    var lbtype = this.data.lbtype;
    if (lbtype == 1) {
      that.setData({
        lbpd: 1,
        shouquan: 0
      })
      var worklb = wx.getStorageSync("worklb");
      var str = Api.HOST + "Public/yanzheng/er.png";
      that.setData({
        result: 1,
      })
      that.main(worklb[0], str, worklb[1]);
      // this.User1();
    } else if (lbtype == 2) {
      that.setData({
        result: 1,
        shouquan: 1
      })
      var str = Api.HOST + "Public/yanzheng/er.png";
      var src = wx.getStorageSync('qrSrc');
      that.main(src, str);
    } else {
      // this.User();
    }
  },
  changet: function(e){
    // console.log(e)
    var txt = e.detail.value;
    this.setData({txt:txt})
  },
  onBlur: function(){
    wx.hideKeyboard()
  }

})