
var Api = require('../../utils/api.js');
var app = getApp();
// pages/cashregister/cashregister.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    img: Api.HOST + 'Public/yanzheng/logo.png',
    nickname: '',
    title: '提现记录',
    money: '',
    num: '',
    recordDta: '',
    winH: ''
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    var that = this;
    wx.getSystemInfo({
      success: (res) => {
        console.log(res.model)
        if (/^iPhone X.*/i.test(res.model)) {
          that.setData({
            iPhoneX: true,
            winH: res.windowHeight - 75
          })
        } else {
          that.setData({
            iPhoneX: false,
            winH: res.windowHeight - 50
          })
        }
      }
    });
    var userInfo = wx.getStorageSync('userInfo');
    if (userInfo) {
      this.setData({
        img: userInfo.avatarUrl,
        nickname: userInfo.nickName,
      })
    }
    var url = Api.HOST + 'wechat.php?s=Home/isTiXian';
    // var url = 'http://localhost/xiaodong/kongtian/wechat.php?s=Home/percenter';
    var data = {};
    var user = wx.getStorageSync('user');
    console.log(user, 'lllll');
    data.unionid = user.unionid;
    Api.fetchPost(url, data, (err, res) => {
      console.log(res);
      var recor404 = (res.info.length == 0)?0:1;
      that.setData({
        money: res.counMont,
        num: res.vipCount,
        recordDta: res.info,
        recor404: recor404
      });
    });

    wx.setNavigationBarTitle({
      title: "提现记录"
    })
  },
  goDetail: function (e) {
    var num = e.currentTarget.dataset.id;
    wx.navigateTo({
      url: '../cashDetail/cashDetail?type=0&id=' + num,
    })
  },
  goInco: function () {
    wx.redirectTo({
      url: '../cashregister/cashregister',
    })
  },
  goExpe: function () {
    wx.redirectTo({
      url: '../zhichuRecord/zhichuRecord',
    })
  },
  goWith: function () {
    wx.redirectTo({
      url: '../cashRecord/cashRecord',
    })
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

})