// pages/dati05/dati05.js
var Api = require('../../utils/api.js');
var util = require('../../utils/util.js');
var app = getApp();
Page({
  /**
   * 页面的初始数据
   */
  data: {
    flag:true,
    rwdate: '2015-07-01',
    nextFalg: {
      0: true
    },
    cause: {
      7: '',
      11: {
        0: 0,
        1: 0
      },
      12: {
        0: 0,
        1: 0
      },
      13: {
        0: 0,
        1: 0
      },
      14: {
        0: 0,
        1: 0
      },
      15: '',
      16: 0,
    },
    disab: true,
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.setData({
      lb_id: options.id
    })
    var answer_swiper = wx.getStorageSync('answer_swiper');//续答存的成绩
    var swiper_arr = wx.getStorageSync('swiper_arr');//题目
    var lb_descript = wx.getStorageSync('lb_descript');//量表信息
    var yanzhengid = wx.getStorageSync('yanzhengid');
    let len = answer_swiper != '' ? (answer_swiper.answer.length < swiper_arr[1].length ? answer_swiper.answer.length : swiper_arr[1].length - 1) : 0;
    if (len > 6) {
      this.setData({
        cause: answer_swiper.cause
      })
    }
    if (false) {} else {
      if (lb_descript.desc.record_id == -1) {
        this.loadData();
      } else if (yanzhengid == lb_descript.desc.record_id) {
        if (len > 0) {
          var item = swiper_arr[1][len];
          var nextFalg = this.data.nextFalg;
          // 处理最后一题的选择问题
          if (swiper_arr[1].length == answer_swiper.answer.length) {
            var last_len = swiper_arr[1].length - 1; // 最后一题序号
            var ind_len = answer_swiper.answer[last_len]; // 最后答案
            var con_len = swiper_arr[1][last_len].score; //  最后问题的答案
            console.log(answer_swiper.answer[answer_swiper.answer.length - 1], item, 'item')
            for (let i = 0; i < con_len.length; i++) {
              // console.log('????', ind_len,con_len[i])
              if (ind_len == con_len[i]) {
                this.setData({
                  active: i,
                  disab: false,
                  nextFalg: nextFalg
                })
              }
            }
          }
          this.setData({
            item: item,
            current: len,
            all: swiper_arr[1].length,
            nextFalg: nextFalg,
          })

        } else {
          this.loadData();
        }
      } else {
        this.loadData();
      }
    }
  },
  loadData: function () {
    var lb_swiper_con = wx.getStorageSync('lb_swiper_con');
    var lb = lb_swiper_con[1];
    var arr = [];
    var an = ['A.', 'B.', 'C.', 'D.', 'E.', 'F.', 'G.', 'H.', 'I.'];
    let zimu = [];
    for (let j in lb) {
      let le = lb[j].quesion_answer.split(',').length;
      var obj = {
        con: lb[j].quesion_title,
        answer: lb[j].quesion_answer.split(','),
        score: lb[j].quesion_score.split(','),
        type: lb[j].type,
        check: [],
        zimu: an
      }
      obj.check.length = obj.answer.length;
      for (let i = 0; i < obj.answer.length; i++) {
        obj.check[i] = 0;
      }
      arr.push(obj)
    }
    var swiper_arr = [lb_swiper_con[0], arr];
    wx.setStorageSync('swiper_arr', swiper_arr);
    var lb_swiper_con = wx.getStorageSync('lb_swiper_con');
    var answerData = {
      score: [this.data.rwdate],
      answer: [this.data.rwdate],
      id: lb_swiper_con[0].measure_id,
      cause: this.data.cause
    }
    var yanzhengid = -1;
    wx.setStorageSync('answer_swiper', answerData);
    wx.setStorageSync('yanzhengid', yanzhengid);
    var timeArr = [];
    wx.setStorageSync("timeArr", timeArr);
    // wx.removeStorageSync('lb_swiper_con')
    var item = swiper_arr[1][0];
    var nextFalg = {
      0: true
    }
    this.setData({
      all: arr.length,
      current: 0,
      item: item,
      nextFalg: nextFalg
    });

    wx.setNavigationBarTitle({
      title: swiper_arr[0].measure_name
    });
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },
  onShow: function () {
    let that = this;
    var swiper_arr = wx.getStorageSync('swiper_arr');
    if (swiper_arr) {
      wx.setNavigationBarTitle({
        title: swiper_arr[0].measure_name
      });
    }
    var timestamp = (new Date()).valueOf();
    wx.getSystemInfo({
      success: (res) => {
        that.setData({
          // winH: res.windowHeight,
          winW: res.windowWidth,
          endTime: util.timestampToTime(timestamp)
        })
      }
    });
    var startTime = Date.parse(new Date());
    var cha = wx.getStorageSync('chaTime') ? wx.getStorageSync('chaTime') : 0;
    wx.setStorageSync('startTime', Number(startTime));
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {
    var endtTime = Date.parse(new Date());
    var startTime = wx.getStorageSync('startTime');
    var cha = endtTime - startTime;
    var arr = wx.getStorageSync("timeArr");
    if (Number(cha) < 1000000040000) {
      arr.push(Number(cha))
      wx.setStorageSync("timeArr", arr);
    }
  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
    var endtTime = Date.parse(new Date());
    var startTime = wx.getStorageSync('startTime');
    var cha = endtTime - startTime;
    var arr = wx.getStorageSync("timeArr");
    if (Number(cha) < 1000000040000) {
      arr.push(Number(cha))
      wx.setStorageSync("timeArr", arr);
    }
  },
  bindDateChange: function (e) {
    this.setData({
      rwdate: e.detail.value
    })
    var answer_swiper = wx.getStorageSync("answer_swiper");
    var num = this.data.current; // 从0开始 不用加1 和数组下标对应
    answer_swiper.answer[num] = e.detail.value;
    answer_swiper.score[num] = e.detail.value;
    wx.setStorageSync("answer_swiper", answer_swiper)
  },
  bindIdCard: function (e) {
    this.setData({
      idCard: e.detail.value,
    })
    console.log(Api.validateIdCard(e.detail.value))
    if (Api.validateIdCard(e.detail.value)) {
      console.log(1)
      var answer_swiper = wx.getStorageSync("answer_swiper");
      var num = this.data.current; // 从0开始 不用加1 和数组下标对应
      answer_swiper.answer[num] = e.detail.value;
      answer_swiper.score[num] = e.detail.value;
      wx.setStorageSync("answer_swiper", answer_swiper);
      this.setData({
        disab: false,
      })
    }else if(!Api.validateIdCard(e.detail.value)&&e.detail.value.length==18){
      console.log(2)
      var answer_swiper = wx.getStorageSync("answer_swiper");
      var num = this.data.current; // 从0开始 不用加1 和数组下标对应
      answer_swiper.answer[num] ='';
      answer_swiper.score[num] = '';
      wx.setStorageSync("answer_swiper", answer_swiper);
      this.setData({
        disab: true,
      })
      wx.showToast({
        title: '请填写真实身份证！',
        icon: 'none',
        duration: 2000
      });
    }   else{
      console.log(3)
      var answer_swiper = wx.getStorageSync("answer_swiper");
      var num = this.data.current; // 从0开始 不用加1 和数组下标对应
      answer_swiper.answer[num] ='';
      answer_swiper.score[num] = '';
      wx.setStorageSync("answer_swiper", answer_swiper);
      this.setData({
        disab: true,
      })
    }
  },
  prev: function (e) {
    if (this.data.current > 0) {
      var record = this.data.current - 1;
      this.prevAnimation();
      var swiper_arr = wx.getStorageSync('swiper_arr');
      let len = swiper_arr[1].length;
      var answer_swiper = wx.getStorageSync('answer_swiper');
      var item = swiper_arr[1][record];
      var nextFalg = this.data.nextFalg;
      nextFalg[record] = true;
      this.setData({
        active: answer_swiper.answer[Number(record)],
        current: record,
        item: item,
        nextFalg: nextFalg
      })
    }
  },
  prevAnimation: function () {
    var that = this;
    var _thisWidth = Number(this.data.winW);
    var animation = wx.createAnimation({
      duration: 300,
      timingFunction: 'linear',
    })
    this.animation = animation
    animation.left(_thisWidth * 2).opacity(1).step();
    this.setData({
      animationData: animation.export()
    })
    setTimeout(function () {
      var animation1 = wx.createAnimation({
        duration: 0,
        timingFunction: 'step-start',
      })
      that.animation = animation1
      animation1.left(_thisWidth / 2).opacity(1).step();
      that.setData({
        animationData: animation1.export()
      })
    }, 310)
  },
  selectData: function (e) {
    let that = this;
    var qufentime = wx.getStorageSync('qufentime');
    var lb_descript = wx.getStorageSync('lb_descript');
    wx.setStorageSync('yanzhengid', lb_descript.desc.record_id);
    // var lb_swiper_con = wx.getStorageSync('lb_swiper_con');
    var swiper_arr = wx.getStorageSync('swiper_arr');
    var answer_swiper = wx.getStorageSync('answer_swiper');
    let len = swiper_arr[1].length;
    var record = e.currentTarget.dataset.record;
    var index = e.currentTarget.dataset.index;
    // var answer = e.currentTarget.dataset.answer;
    var score = e.currentTarget.dataset.score;
    var nextFalg = this.data.nextFalg;
    nextFalg[record] = true;
    this.setData({
      nextFalg: nextFalg
    })
    this.setData({
      active: index,
      all: len,
      current: Number(record)
    })
    if (answer_swiper.score.length <= record) {
      answer_swiper.score.push(score);
      answer_swiper.answer.push(index);
    } else {
      answer_swiper.score[record] = score;
      answer_swiper.answer[record] = index;
    }
    wx.setStorageSync('answer_swiper', answer_swiper);

  },
  //题8
  cause(e) {
    var current = e.currentTarget.dataset.current
    var value = e.detail.value;
    var cause = this.data.cause;
    if (current == 7 || current == 15) {
      cause[current] = value.replace(".","").replace(",","");
    } else if (current == 16) {
      cause[current] = Number(value);
    } else {
      cause[current][e.currentTarget.dataset.type] = Number(value);
    }
    this.setData({
      cause: cause
    })
    var answer_swiper = wx.getStorageSync('answer_swiper')
    answer_swiper.cause = cause;
    wx.setStorageSync('answer_swiper', answer_swiper)
  },
  next: function (n) {
    if (!(/(^[0-9]*$)/.test(n))) n = n.currentTarget.dataset.cur;
    var answer_swiper = wx.getStorageSync('answer_swiper');
    if (answer_swiper.answer[n].length <= 0) {
      wx.showToast({
        title: '请选择',
        icon: 'none',
        duration: 1000
      });
      return;
    }
    switch (n) {
      case 7:
        if (answer_swiper.answer[n] > 1 && answer_swiper.cause[n].length < 1) {
          wx.showToast({
            title: '请填写原因',
            icon: 'none',
            duration: 2000
          });
          return;
        }
        break;
      case 11:
      case 12:
      case 13:
      case 14:
        if (answer_swiper.answer[n] ==0&& (answer_swiper.cause[n][0] < 1||answer_swiper.cause[n][1] < 1)) {
          wx.showToast({
            title: '请填写正确数量',
            icon: 'none',
            duration: 2000
          });
          return;
        }
        break;
      case 15:
        if (answer_swiper.answer[n] ==0&&answer_swiper.cause[n].length < 1) {
          wx.showToast({
            title: '请填写原因',
            icon: 'none',
            duration: 2000
          });
          return;
        }
        break;
        case 16:
          if (answer_swiper.answer[n] ==0&&answer_swiper.cause[n].length < 1) {
            wx.showToast({
              title: '请填写原因',
              icon: 'none',
              duration: 2000
            });
            return;
          }
         break;
    }
    if (answer_swiper.answer[n].length <= 0) {
      wx.showToast({
        title: '请选择',
        icon: 'none',
        duration: 1000
      });
      return;
    }

    var swiper_arr = wx.getStorageSync('swiper_arr');
    let len = swiper_arr[1].length;
    if (n < len-1) {
      // this.nextAnimation();
      var item = swiper_arr[1][n + 1]
      var answer_swiper = wx.getStorageSync('answer_swiper');
      var an_len = answer_swiper.answer ? answer_swiper.answer.length : -1;
      if (an_len - n > 1) {
        // 多选题 的数据状态
        if (this.data.multipleChoice && (n + 1 == 4 || n + 1 == 8 || n + 1 == 9 || n + 1 == 10 || n + 1 == 14)) {
          let ans = answer_swiper.answer[n + 1];
          let ansArr = ans.split('|');
          for (let i = 0; i < ansArr.length; i++) {
            item.check[ansArr[i]] = 1;
          }
        } else if (this.data.sheqv && (n + 1 == 12 || n + 1 == 19)) {
          let ans = answer_swiper.answer[n + 1];
          let ansArr = ans.split('|');
          for (let i = 0; i < ansArr.length; i++) {
            item.check[ansArr[i]] = 1;
          }
        }
        this.setData({
          active: answer_swiper.answer[n + 1],
          // active: -1,
          item: item,
          all: len,
          current: n + 1
        })
      } else {
        this.setData({
          active: -1,
          item: item,
          all: len,
          current: n + 1
        })
      }

    } 
  },

  tijiao: function () {
    let that = this;
    var lb_descript = wx.getStorageSync('lb_descript');
    if (this.data.flag && !this.data.disab) {
      this.setData({
        flag: false
      })
      wx.showLoading({
        title: '上传中...',
        mask: true,
      })
      // var timer = setTimeout(function () {
      //   wx.showToast({
      //     title: '请稍后再试',
      //     icon: 'none',
      //     duration: 2000,
      //     success: function () {

      //     }
      //   })
      // }, 8000)
      var startTime = wx.getStorageSync('startTime');
      var timeArr = wx.getStorageSync('timeArr');
      var chaTime = 0;
      for (let i = 0; i < timeArr.length; i++) {
        if (Number(timeArr) > 1000000040000) {
          timeArr[i] = 0;
        }
        chaTime += timeArr[i]
      }
      var thisTime = Date.parse(new Date());
      var cha = thisTime - startTime + chaTime;
      var time = Api.reversalTime(cha)
      var user = wx.getStorageSync('user');
      var answer = wx.getStorageSync('answer_swiper');
      for (let i = 0; i < answer.score.length; i++) {
        if(i==7&&answer.answer[i]>1){
          answer.score[i] = answer.score[i]+'.'+answer.cause[7];
        }else if((i==11||i==12||i==13||i==14)&&answer.answer[i]==0){
          answer.score[i] = answer.score[i]+'.'+answer.cause[i][0]+'.'+answer.cause[i][1];
        }else if((i==15||i==16)&&answer.answer[i]==0){
          answer.score[i] = answer.score[i]+'.'+answer.cause[i];
        }
        answer.score[i] = answer.score[i].replace(/[\r\n]/g, '');
      }
      var lb_descript = wx.getStorageSync('lb_descript');
      var swiper_arr = wx.getStorageSync('swiper_arr');
      var lb_tp = wx.getStorageSync('lb_tz')
    //   if (lb_tp == '1') {
    //     var data = {
    //       user_stime: time,
    //       user_answer: answer.score,
    //       answer: answer.answer,
    //       user_number: lb_descript.desc.z_openid,
    //       measure_id: lb_descript.id[0],
    //     };
    //     var url = Api.HOST_xinli + 'xinli/index.php/Api/add_res';
    //   } else {
    //     var data = {
    //       user_stime: time,
    //       user_answer: answer.score,
    //       answer: answer.answer,
    //       user_number: user.openid,
    //       measure_id: lb_descript.id[0],
    //       g_id: wx.getStorageSync('g_id')
    //     };
    //     var url = Api.HOST_xinli + 'xinli/index.php/Api/add_res';
    //   }
      var stoUser = wx.getStorageSync('user');
      var ndata = {
        measure_id: lb_descript.id[0],
        user_stime: time,
        g_id: wx.getStorageSync('g_id'),
        openid:stoUser.openid ? stoUser.openid : '',
        user_answer: answer.score,
        answer: answer.answer,
     };
      var url = Api.HOST_xlxl + 'amedical.php/gauge/pcAddData';
      ndata.unitid = lb_descript.desc.unitid;
      ndata.uid = 6;
      ndata.submit_type = 2;
      ndata.t_openid = wx.getStorageSync('param_t_openid');
      var uploadData = setTimeout(function () {
        wx.hideLoading()
        wx.showToast({
          icon: 'none',
          title: '您当前的网络不稳定，请检查网络重新提交',
          duration: 2000
        })
        that.setData({
          flag: true
        })
      }, 5000)
      var formdata = wx.getStorageSync('allUserinfo');
      let newdata = Object.assign({...ndata,...formdata});
      newdata = this.removeEmptyProperties(newdata);
      Api.fetchPostN(url, newdata, (err, res) => {
        clearTimeout(uploadData)
        if (Number(res) == 0) {
          Api.alert("提交失败，请重新提交。")
          return;
        }
        if (Number(res.code) == -1) {
            wx.hideLoading();
            Api.alert(res.msg)
            that.setData({
                flag: true
            })
            return;
        }
        var swiper_arr = wx.getStorageSync('swiper_arr');
        var data1 = {};

        // var urls = Api.HOST + 'wechat.php?s=Home/del_vip';
        var urls = Api.HOST_xlxl + 'wechat.php?s=Home/del_vips';
        var ti_title = swiper_arr[0].measure_name;
        var lb_descript = wx.getStorageSync("lb_descript");
        var authorize = wx.getStorageSync('weiLb');
        data1.g_time = lb_descript.desc.g_time || lb_descript.desc.time;
        data1.measure_name = ti_title;
        // data1.res_id = res;
        data1.user_stime = time;
        data1.characters_id = authorize.characters_id ? authorize.characters_id : authorize.record_id;
        var lb_tz = wx.getStorageSync('lb_tz');
        if (lb_tz == '1') {
          var unitid = wx.getStorageSync("unitid");
          var tp_characters_id = wx.getStorageSync("tplbDetail");
          data1.unitid = unitid;
          data1.characters_id = tp_characters_id.g_id;
          data1.z_openid = lb_descript.desc.z_openid;
          data1.t_openid = lb_descript.desc.t_openid;
          data1.openid = lb_descript.desc.z_openid;
          data1.is_type = 0;
          data1.measure_id = lb_descript.id[0];
        } else {
          data1.z_openid = user.openid;
          data1.t_openid = lb_descript.desc.t_openid;
          data1.openid = user.openid;
          data1.is_type = 1;
          data1.unitid = lb_descript.desc.unitid;
          data1.measure_id = lb_descript.id[0];
        }
        // clearTimeout(timer)
        Api.fetchPost(urls, data1, (err, res) => {
          if (err) {
            that.setData({
              flag: true
            })
          }
          that.setData({
            flag: true
          })
          if (res == 1 || res == 0) {
            wx.removeStorageSync('answer_swiper')
            wx.removeStorageSync('swiper_arr')
            wx.removeStorageSync('chaTime')
            wx.removeStorageSync('endTime')
            wx.removeStorageSync('startTime')
            wx.removeStorageSync('timeArr')
            wx.removeStorageSync('lb_swiper_con')
            wx.hideLoading();

          } else {
            wx.hideLoading()
            wx.showToast({
              title: '请稍后再试',
              icon: 'none',
              duration: 2000
            })
          }
          if (res == 1) {
            // clearTimeout(timer)
            wx.showToast({
              title: '上传成功',
              icon: 'success',
              duration: 2000
            })
            wx.removeStorageSync('canvas')
            setTimeout(function () {
              var lb_tz = wx.getStorageSync('lb_tz');
              if (lb_tz == '1') {
                wx.reLaunch({
                  url: '/pages/info1/info1?otype=1&otype1=1',
                  success: function () {
                    that.setData({
                      flag: true
                    })
                  }
                })
              } else {
                var g_id = wx.getStorageSync('g_id');
                wx.reLaunch({
                  url: `/pages/info/info?otype=1&otype1=1&ishow=1&g_id=${g_id}`,
                  success: function () {
                    that.setData({
                      flag: true
                    })
                  }
                })
              }
            }, 2000)
          } else if (res == 0) {
            // clearTimeout(timer)
            wx.showToast({
              title: '上传成功',
              icon: 'success',
              duration: 2000
            })
            setTimeout(function () {
              wx.removeStorageSync('tplbDetail')
              wx.removeStorageSync('weiLb')
              wx.reLaunch({
                // url: '/pages/end/end?lbtype=-1',
                url: '/pages/record/record',
                success: function () {
                  that.setData({
                    flag: true
                  })
                  wx.removeStorageSync('lb_descript');
                  wx.removeStorageSync('allUserinfo');
                  wx.removeStorageSync('g_id');
                  wx.removeStorageSync('param_t_openid');
                }
              })
            }, 2000)
          }
        })
      })
    }
  },
  removeEmptyProperties:function (obj) {
    // 将对象转换为 [key, value] 数组
    const entries = Object.entries(obj);
    // 过滤掉属性值为空字符串的属性
    const filteredEntries = entries.filter(([key, value]) => value !== ""&&value != 0&&value != 'undefined'&&value != null&&value != 'null'&&value != 'NULL');
    // 将过滤后的数组转换回对象
    const filteredObj = Object.fromEntries(filteredEntries);
    return filteredObj;
  },
})