// pages/result02/result02.js
var Api = require('../../utils/api.js');
const app = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    item: {
      img: "https://wx.qlogo.cn/mmopen/vi_32/Q0j4TwGTfTJ7icUSuTGicA7FeVId7OicCAp7Jcr4bBe7MKQ4HAFWNPKN2Hbsl8UYJ0DuDP7KsPofQM9JlZP5GxqTA/0",
      nickname: '冰是沉默的水',
      name: 'wjm',
      xb: '../../../images/F.png',
      xueli: '初中',
      age: 20
    },
    result: {
      title: '诊断说明',
      char: [
        ["思维障碍", "没有明显的思维障碍,思维条理性、逻辑性和现实性基本正常, 能够比较客观地认识自己与环境之间的关系。"],
      ],
      num: ''
    },
    ceping: {
      title: '测评结果',
      th: ['测评指标', '分值', '参考值'],
      arr: [
        ['总粗分', '63', '40'], ['总粗分', '63', '40'], ['总粗分', '63', '40'], ['调节情绪能力', '63', '较差']
      ]
    },
    ceping1: {
      title: '测评结果',
      th: ['测评指标', '分值', '参考值'],
      arr: [
        ['总粗分', '63', '40'], ['总粗分', '63', '40'], ['总粗分', '63', '40'], ['调节情绪能力', '63', '较差']
      ]
    },
    ceping2: {
      title: 'EPQ量表剖析图',
      src: ''
    },
    ceping3: {
      title: 'EPQ量表剖析图',
      src: ''
    },
    ceping4: {
      title: '因子分',
      th: ['因子分', '分值', '参考(M+SD)', '程度'],
      arr: [
        ['总粗分', '63', '40'], ['总粗分', '63', '40'], ['总粗分', '63', '40'], ['调节情绪能力', '63', '较差']
      ]
    },
    lbtype: -2,
    itemBtn: { index: -1, unitid: '' },
    winH: '',
    num: ''
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    let that = this;
    console.log(options, 'options')
    var res_id = options.id;
    var lbname = options.lbname;
    wx.setNavigationBarTitle({
      title: lbname
    });
    wx.getSystemInfo({
      success: (res) => {
        if (/^iPhone X.*/i.test(res.model)) {
          that.setData({
            iPhoneX: true,
            winH: res.windowHeight - 75
          })
        } else {
          that.setData({
            iPhoneX: false,
            winH: res.windowHeight - 50
          })
        }
      }
    });
    var item = {}; 
    var res_id1 = options.res_id1;
    if (typeof (res_id1) == 'undefined') {
      var person = wx.getStorageSync('person');
      if (person.xb == '男') {
        item.xb = '../../images/F.png'
      } else {
        item.xb = '../../images/M.png'
      }
      item.name = person.name;
      item.img = person.img;
      item.age = person.age;
      item.xueli = person.xueli;
      this.setData({
        item: item,
        lbname: lbname,
        res_id: res_id,
        num: options.num
      })
    }else{
      item.name = '小懂健康用户';
      item.img = Api.HOST + 'Public/yanzheng/logo.png';
      item.age = options.age;
      item.xueli = options.xueli;
      if (options.xb == '男') {
        item.xb = '../../images/F.png'
      } else {
        item.xb = '../../images/M.png'
      }
      this.setData({
        item: item,
        lbname: lbname,
        res_id: res_id,
        num: options.num
      })
    }
  //  显示个人信息
    var unitid = wx.getStorageSync('unitid');
    if (unitid == 'false' || unitid == '') {
      if (this.data.iPhoneX) {
        var obj = { index:-1, unitid: false, iphonex: true };
      } else {
        var obj = { index: -1, unitid: false, iphonex: false };
      }
      this.setData({
        itemBtn: obj
      })
    } else {
      if (this.data.iPhoneX) {
        var obj = { index: -1, unitid: true, iphonex: true };
      } else {
        var obj = { index: -1, unitid: true, iphonex: false };
      }
      this.setData({
        itemBtn: obj
      })
    }
    // 判断用户身份
    var scene = wx.getStorageSync('scene');
    if (scene == 1007) {
      this.puanDuanShenFen(options);
    }
    // 加载数据
    if (typeof (res_id1) == 'undefined') {
      var user = wx.getStorageSync('user');
      var openid = user.openid;
      this.loadData(res_id, openid);
    } else {
      var openid = options.openid;
      this.loadData(res_id1, openid);
    }

  },
  loadData: function (n, d) {
    let that = this;
    var data = {};
    var url = Api.HOST + 'wechat.php?s=Home/del_vip';
    data.res_id = n;
    data.openid = d;
    Api.fetchPost(url, data, (err, res) => {
      console.log(res,'del-vip')
      var otype = Number(res.type);
      if (otype == 1) {
        that.yiYuZiPing(res);
      } else if (otype == 2) {
        that.zhengZhuangZiPing(res);
      } else if (otype == 3) {
        that.aiKeChengRen(res);
      } else if (otype == 4) {
        that.aiKeErTong(res)
      } else if (otype == 5) {
        that.hanMiYiYu(res)
      } else if (otype == 6) {
        that.xueShengGuanLi(res)
      } else if (otype == 7) {
        that.fangYu(res)
        // that.jiankang(res)
      } else if (otype == 8) {
        that.kaTeEr(res)
      } else if (otype == 9) {
        that.ruiWen(res)
      } else if (otype == 10) {
        that.yingFu(res)
      } else if (otype == 511){
        // that.jingzhui(res)
        that.jiankang(res)
      } else {
        that.jiankang(res)
        // that.common(res)
      }
    })
  },
  // common
  common: function(data){
    console.log(data, 'data')
    var ceping1={
      title:'sdsds',
      th:[]
    }
    if(2){
      ceping1.th = ['检测指标', '', 'T分']
    }else{
      ceping1.th = ['检测指标', 'sdsds', 'T分']
    }


    var result={
      title: '总体特征',

    }
    this.setData({
      lbtype: 0,
      cepingCom: ceping1,
      result: result
    })
  },
  // 儿童青少年心理健康风险早期筛查
  jiankang: function(data){
    console.log(data, 'data')
    var ceping3 = {
      title: '总分测评',
      char: [[data.factor]],
      num: '',
      score: true
    }
    ceping3.num = ceping3.char.length;
    var ceping1 = {
      title: data.title[0],
      th: [data.data_name[0], '', data.data_name[1]],
      arr: data.data,
      // data_arr: d_arr
    }
    var result = {
      title: data.title[1],
      char: data.res,
      num: ''
    }
    // var s = [['轻度抑郁倾向', '没有明显的思维障碍,思维条理性、逻辑性和现实性基本正常, 能够比较客观地认识自己与环境之间的关系。'], ['轻度抑郁倾向', '轻度的抑郁,心情比较压抑,缺乏自信,容易紧张和害羞,精力减退,食欲睡眠差,易疲乏,注意和记忆力减退;如果症状持续时间长,影响工作学习,应该请专业人员进行检查.'], ['轻度抑郁倾向', '目前没有明显焦虑。'], ['轻度抑郁倾向', '网络成瘾倾向不明显。']]
    // result.char = s;
    // result.num = s.length;
    result.num = result.char.length;
    this.setData({
      lbtype: 11,
      ceping3: ceping3,
      ceping1: ceping1,
      result: result
    })
  },
  // 公共样式
  common: function(data){

  },
  // 应付方式
  yingFu: function (data) {
    var ceping1 = {
      title: '结果解释',
      th: ['因子名称', '', '因子分'],
      arr: data.data,
    }
    var result = {
      title: '诊断结果',
      char: data.result_str,
      num: ''
    }
    result.num = result.char.length;
    this.setData({
      lbtype: 10,
      ceping1: ceping1,
      result: result
    })
  },
  // 瑞文
  ruiWen: function (data) {
    console.log(data, 'data')
    var data_arr = [];
    for (let i = 0; i < data.data.length; i++) {
      let arr = [];
      arr[0] = data.data[i][0];
      arr[1] = '';
      arr[2] = data.data[i][1];
      data_arr.push(arr)
    }
    var all = [];
    for (let j in data.factor) {
      let a = [];
      a[0] = j;
      a[1] = data.factor[j];
      all.push(a)
    }
    var ceping = {
      title: '测试数值',
      th: ['单元', '', '分数'],
      arr: data_arr,
      data_arr: all,
    }
    var txt_arr = [];
    txt_arr = data.res[1].split(":");
    var result = {
      title: data.res[0],
      char: [txt_arr, data.Remarks],
      num: ''
    }
    result.num = result.char.length;
    this.setData({
      lbtype: 9,
      ceping: ceping,
      result: result
    })
  },
  // 卡特尔
  kaTeEr: function (data) {
    console.log(data, 'data')
    var d_arr = [];
    for (var i in data.data[2]) {
      let arr = [i, data.data[2][i]]
      d_arr.push(arr);
    }
    var ceping5 = {
      title: data.data[0],
      th: ['人格因素', '原始分', '标准分'],
      arr: data.data[1],
      data_arr: data.data[2]
    }
    var d_arr1 = [];
    for (var i in data.yinsu_arr[1]) {
      let arr = [i, data.yinsu_arr[1][i]]
      d_arr1.push(arr);
    }
    var ceping6 = {
      title: data.data[0],
      arr: data.yinsu_arr[0],
      data_arr: d_arr1
    }
    var res = [];
    for (let i = 0; i < data.result_str.High_arr[1].length; i++) {
      res.push(data.result_str.High_arr[1][i].split(":"));
    }
    var res1 = [];
    for (let i = 0; i < data.result_str.low_arr[1].length; i++) {
      res1.push(data.result_str.low_arr[1][i].split(":"));
    }
    var result = {
      title: data.result_str.High_arr[0],
      char: res,
      num: ''
    }
    result.num = result.char.length;
    var result1 = {
      title: data.result_str.low_arr[0],
      char: res1,
      num1: ''
    }
    result1.num = result1.char.length;
    var result2 = {
      title: data.result_str.High_arr[0],
      char: res,
      num: ''
    }
    result1.num = result.char.length;
    var char1 = [];
    for (var i in data.res[1]) {
      let arr = [i, data.res[1][i]]
      char1.push(arr);
    }

    var result2 = {
      title: data.res[0],
      char: char1,
      num1: ''
    }
    result2.num = result2.char.length;
    var result3 = {
      title: data.data[0],
      char: data.data[2],
      num1: ''
    }
    result3.num = result3.char.length;
    var result4 = {
      title: data.yinsu_arr[0],
      char: data.yinsu_arr[1],
      num1: ''
    }
    result4.num = result4.char.length;
    this.setData({
      lbtype: 8,
      ceping5: ceping5,
      ceping6: ceping6,
      result: result,
      result1: result1,
      result2: result2,
      result3: result3,
      result4: result4
    })
  },
  // 防御方式
  fangYu: function (data) {
    console.log(data, 'data')
    var d_arr = [];
    for (var i in data.data_arr) {
      let arr = [i, data.data_arr[i]]
      d_arr.push(arr);
    }
    var ceping1 = {
      title: '测试结果',
      th: ['防御机制', '', '均分'],
      arr: data.data,
      data_arr: d_arr
    }
    var result = {
      title: '诊断结果',
      char: [data.res],
      num: ''
    }
    result.num = result.char.length;
    this.setData({
      lbtype: 7,
      ceping1: ceping1,
      // ceping2: ceping2,
      // ceping3: ceping3,
      result: result
    })
  },
  // 汉密顿抑郁
  hanMiYiYu: function (data) {
    console.log(data, 'data')
    var ceping = {
      title: '因子分析',
      th: ['项目名称', '因子分', '均分'],
      arr: data.data
    }
    var ceping3 = {
      title: '总分测评',
      char: [[data.factor]],
      num: '',
      score: true
    }
    ceping3.num = ceping3.char.length;
    var ceping2 = {
      title: '单项测评',
      th: ['项目名称', '得分', '程度'],
      arr: data.data_arr,
      
    }
    var result = {
      title: '诊断说明',
      char: [[data.res[0],data.res[1]]],
      num: ''
    }
    result.num = result.char.length;
    this.setData({
      lbtype: 5,
      ceping: ceping,
      ceping2: ceping2,
      ceping3: ceping3,
      result: result
    })
  },
  // 中学生健康管理
  xueShengGuanLi: function (data) {
    console.log(data, 'data')
    var ceping = {
      title: '行为问题测查',
      th: ['因子', '标准分', '结果'],
      arr: data.data_arr,
      score: data.factor
    }
    var result = {
      title: '诊断说明',
      char: [data.res],
      num: 0
    }
    result.num = result.char.length;
    this.setData({
      lbtype: 6,
      ceping: ceping,
      result: result
    })
  },
  // 艾克儿童
  aiKeErTong: function (data) {
    console.log(data, 'data')
    var host = Api.HOST_xinli +'/xinli';
    // var host = 'https://vivshi.com/xiaodong_test/xinli';
    var src1 = this.dealPho(data.img[0][1], host);
    var ceping = {
      title: 'EPQ结果',
      th: ['量表', '粗分', 'T分'],
      arr: data.data
    }
    var result = {
      title: '结果解释',
      char: data.data_res,
      num: 0
    }
    var ceping3 = {
      title: data.img[0][0],
      src: src1,
      hei: 590,
      wid: 730,
      arr_data: [data.res],
      num1: ''
    }
    // ceping3.arr_data = [[1, 2], [1, 2], [1, 2],[1, 2]]
    console.log(ceping3.arr_data,'ceping3.char')
    ceping3.num1 = ceping3.arr_data.length;
    result.num = result.char.length;
    console.log(result)
    this.setData({
      lbtype: 4,
      ceping: ceping,
      ceping3: ceping3,
      result: result
    })
  },
  // 艾克成人
  aiKeChengRen: function (data) {
    console.log(data, 'data')
    var ceping = {
      title: 'EPQ结果',
      th: ['量表', '粗分', 'T分'],
      arr: data.data
    }
    var host = Api.HOST_xinli + '/xinli';
    // var host = 'https://vivshi.com/xiaodong_test/xinli';
    var src1 = this.dealPho(data.img[0][1], host);
    var src2 = this.dealPho(data.img[1][1], host);
    var ceping2 = {
      title: data.img[0][0],
      src: src1,
      hei: 640,
      win: 680
    }
    var ceping3 = {
      title: data.img[1][0],
      src: src2,
      win: 780,
      hei: 680
    }
    var result = {
      title: '个性特征分析',
      char: [],
      num: 0
    }
    for (let i = 0; i < data.res.length; i++) {
      result.char.push(this.parsingData1(data.res[i]));
    }
    result.char.num = result.char.length;
    this.setData({
      lbtype: 3,
      ceping: ceping,
      ceping2: ceping2,
      ceping3: ceping3,
      result: result
    })
  },
  //症状自评量表 
  zhengZhuangZiPing: function (data) {
    var ceping = {
      title: '统计指标',
      th: ['统计指标', '得分', '参考(M+SD)'],
      arr: data.data[0]
    }
    var ceping4 = {
      title: '因子分',
      th: ['因子分', '分值', '参考(M+SD)', '程度'],
      arr: data.data[1]
    }
    var result = {
      title: '诊断说明',
      char: [],
      num: 0
    }
    for (let i = 0; i < data.res.length; i++) {
      result.char.push(this.parsingData(data.res[i]));
    }
    result.char.num = result.char.length;
    this.setData({
      lbtype: 2,
      ceping: ceping,
      ceping4: ceping4,
      result: result
    })
  },
  // 抑郁焦虑自评量表
  yiYuZiPing: function (data) {
    console.log(data,'data')
    var ceping = {
      title: '测评结果',
      th: ['测评指标', '分值', '参考值'],
      arr: data.data
    }
    var result = {
      title: '诊断说明',
      char: [[data.res[0], data.res[1]]],
      num: ''
    }
    result.num = result.char.length;
    this.setData({
      lbtype: 1,
      ceping: ceping,
      result: result
    })
  },
  parsingData: function (e) {
    var str = e.replace(/：/, ":+");
    var arr = str.split(':+');
    return arr;
  },
  parsingData1: function (e) {
    var s = e.replace(/&nbsp;/g, '');
    var arr = s.split(':');
    return arr;
  },
  dealPho(str, host) {
    var s = host + str;
    return s;
  },
  /**
   * 判断用户身份
   * */
  puanDuanShenFen: function (options){
    let that = this;
    // app.getUserInfo(function (userInfo) {
      var userInfo = wx.getStorageSync('userInfo');
      if (!userInfo) {
        app.getUserInfo();
      }
      var url = Api.HOST + 'wechat.php?s=Home/index';
      var data = {};
      var user = wx.getStorageSync('user');
      data.openid = user.openid;
      data.nickname = userInfo.nickName;
      data.headimgurl = userInfo.avatarUrl;
      // data.opid = options.opid;
      // data.unitid = options.unitid;
      data.unionid = user.unionid;
      data.follow = 2;
      Api.fetchPost(url, data, (err, res) => {
        // wx.setStorageSync('data', res)
        if (res.unitid == null) {
          var unitid = 'false';
          // wx.setStorageSync('unitid', unitid);
          if (that.data.iPhoneX) {
            var obj = { index: -1, unitid: false, iphonex: true };
          } else {
            var obj = { index: -1, unitid: false, iphonex: false };
          }
          that.setData({
            itemBtn: obj
          })
        } else {
          var unitid = res.unitid;
          // wx.setStorageSync('unitid', unitid);
          if (that.data.iPhoneX) {
            var obj = { index: -1, unitid: true, iphonex: true };
          } else {
            var obj = { index: -1, unitid: true, iphonex: false };
          }
          that.setData({
            itemBtn: obj
          })
        }

        if (res.follow == 0) {
          that.setData({
            modal: true
          })
        } else {
          that.setData({
            modal: false
          })
        }
      });
    // });
  }, 
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    let that = this;
    var user = wx.getStorageSync('user');
    var person = wx.getStorageSync('person')
    return {
      title: that.data.lbname,
      imageUrl: Api.HOST+'Public/yanzheng/zf.png',
      path: '/pages/result02/result02?lbname=' + that.data.lbname + '&res_id1=' + that.data.res_id + '&openid=' + user.openid + '&num=' + that.data.num + '&xueli=' + person.xueli+'&age='+person.age+'&xb='+person.xb,
      success: function (res) {
      }
    }
  },
  shouye: function () {
    wx.reLaunch({
      url: '/pages/index/index',
    })
  },
  ceshi: function () {
    if (this.data.modal){
      wx.redirectTo({
        url: '/pages/index/index',
      })
    }else{
      // wx.redirectTo({
      //   url: '/pages/record/record',
      // })
      wx.navigateBack({
        delta:1
      })
    }
  },
  liangbiao: function () {
    if (this.data.modal) {
      wx.redirectTo({
        url: '/pages/index/index',
      })
    } else {
      wx.redirectTo({
        url: '/pages/liangbiao/liangbiao',
      })
    }
  },
  my: function () {
    if (this.data.modal) {
      wx.redirectTo({
        url: '/pages/index/index',
      })
    } else {
      wx.reLaunch({
        url: '/pages/myindex/myindex',
      })
    }
  },
})