var Api = require('../../utils/api.js');
var app = getApp();


Page({

  /**
   * 页面的初始数据
   */
  data: {
    val: '',
    btnInfo: true,
    cz_money:''
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function(options) {
    console.log(options.cz_money)
    this.setData({
      cz_money:options.cz_money
    })
    wx.setNavigationBarTitle({
      title: '储值卡充值',
    });
  },
  bindKeyInput(e) {
    let v = e.detail.value;
    v = this.Trim(v);
    // console.log(v.length, this.data.val.length)
    // v = v.replace(/(.{4})/g, "$1 ")
    v = v.replace(/(\d{4})(?=\d)/g, "$1 ");
    this.setData({
      val: v
    })
  },
  /**
   * 除所有空格
   * @param str
   * @returns
   */
  Trim(str) {
    return str.replace(/\s/g, '');
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function() {

  },
  chargeBtn(e) {
    let that = this;
    if (this.data.btnInfo) {
      this.setData({
        btnInfo: false
      })
      setTimeout(()=>{
        this.setData({
          btnInfo: true
        })
      },5000)
      let id = this.data.val;
      id = this.Trim(id);
      console.log(id)
      if (!id) {
        Api.alert('卡号不能为空');
        return;
      }

      if (!/^[0-9]+$/.test(id)) {
        Api.alert('卡号格式错误');
        return;
      }
      if (id.length != 12) {
        Api.alert('卡号不全');
        return;
      }
      let allData = wx.getStorageSync('data');
      let url = Api.HOST + 'wechat.php?s=Money/recharge_card';
      let cz_money=that.data.cz_money;
      let data = {
        card_id: id,
        unitid: allData.unitid,
        openid: allData.openid
      }
      Api.fetchPost(url, data, (err, res) => {
        console.log('res', res)
        that.setData({
          btnInfo: true
        })
        if (!res) return;
        if (res.code == 1) {
          Api.alert(res.msg);
        } else if (res.code == 2) {
          Api.alert(res.msg);
        } else if (res.code == 3) {
          Api.alert(res.msg, function() {
            wx.navigateTo({
              url: '/pages/prepaidlist/prepaidlist',
            })
          });
        }
      })
    }else{
      wx.showToast({
        title:'请勿重复点击',
        icon:'none'
      })
    }
  },
  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function() {

  },
  goList(){
    wx.navigateTo({
      url: '/pages/prepaidlist/prepaidlist',
    })
  },
  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function() {

  },
})