var Api = require('../../utils/api.js');
var app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    recordDta: [],
    toView: 'load',
    success: 1,
    page: 0,
    scrollFlag: true,
    barFlag: true,
    page: 0,
    record404: '',
    show: false,
    success: ''
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    var that = this;
    wx.getSystemInfo({
      success: (res) => {
        console.log(res.model)
        if (/^iPhone X.*/i.test(res.model)) {
          that.setData({
            iPhoneX: true,
            winH: res.windowHeight
          })
        } else {
          that.setData({
            iPhoneX: false,
            winH: res.windowHeight
          })
        }
      }
    });
    wx.showLoading({
      title: '正在加载',
    })
    var url = Api.HOST + 'wechat.php?s=money/card_list';
    var data = {};
    var allData = wx.getStorageSync('data');
    if (allData.unitid) {
      data.unitid = allData.unitid;
    }
    Api.fetchPostN(url, data, (err, res) => {
      wx.hideLoading()
      // console.log(res, 'res',res.data)
      if(!res) return;
      if (res.data && res.data.length > 0) {
        that.structData(res.data);
        that.setData({ record404: true, show: true })
      } else{
        that.setData({
          record404: false, show: true
        })
      }
    })
    wx.setNavigationBarTitle({
      title: "充值记录"
    });
  },
  structData: function (data) {
    for (let i = 0; i < data.length; i++) {
      data[i].usetime = Api.timestampToTime(data[i].usetime);
      data[i].ordernumber = data[i].ordernumber.replace(/(\d{4})(?=\d)/g, "$1 ");
    }
    this.setData({
      recordDta: data,
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {

  },
  lower: function () {
    
  },
})